aboutsummaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
authorPeter Holm <pho@FreeBSD.org>2021-05-13 05:57:32 +0000
committerPeter Holm <pho@FreeBSD.org>2021-05-13 05:57:32 +0000
commit1025baec7b786df46ee63bf55369cf081002b8af (patch)
tree25a26237ae36cc1a25231902d72574abfda09885 /tools
parentd4870e3a7256704905655e997b37a866024c2894 (diff)
downloadsrc-1025baec7b786df46ee63bf55369cf081002b8af.tar.gz
src-1025baec7b786df46ee63bf55369cf081002b8af.zip
stress2: Added two new syzkaller reproducers. Update the exclude list
Diffstat (limited to 'tools')
-rw-r--r--tools/test/stress2/misc/all.exclude2
-rwxr-xr-xtools/test/stress2/misc/syzkaller37.sh99
-rwxr-xr-xtools/test/stress2/misc/syzkaller38.sh63
3 files changed, 162 insertions, 2 deletions
diff --git a/tools/test/stress2/misc/all.exclude b/tools/test/stress2/misc/all.exclude
index e388fa8957d9..9f856c1b9d2f 100644
--- a/tools/test/stress2/misc/all.exclude
+++ b/tools/test/stress2/misc/all.exclude
@@ -70,8 +70,6 @@ syzkaller30.sh May change policy for random threads to to domainset_fixed 20210
syzkaller31.sh panic: Bad tailq NEXT(0xfffffe0079608f00->tqh_last) != NULL 20210322
syzkaller32.sh Fatal trap 18: integer divide fault while in kernel mode 20210322
syzkaller33.sh Fatal trap 18: integer divide fault while in kernel mode 20210418
-syzkaller35.sh panic: AEAD without a separate IV 20210508
-syzkaller36.sh panic: IV outside buffer length 20210508
truss3.sh WiP 20200915
unionfs.sh insmntque: non-locked vp: xx is not exclusive locked... 20130909
unionfs2.sh insmntque: mp-safe fs and non-locked vp is not ... 20111219
diff --git a/tools/test/stress2/misc/syzkaller37.sh b/tools/test/stress2/misc/syzkaller37.sh
new file mode 100755
index 000000000000..cda44530af85
--- /dev/null
+++ b/tools/test/stress2/misc/syzkaller37.sh
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# panic: crp_iv_start set when IV isn't used
+# cpuid = 15
+# time = 1620460567
+# KDB: stack backtrace:
+# db_trace_self_wrapper() at db_trace_self_wrapper+0x2b/frame 0xfffffe023ceef5d0
+# vpanic() at vpanic+0x181/frame 0xfffffe023ceef620
+# panic() at panic+0x43/frame 0xfffffe023ceef680
+# crp_sanity() at crp_sanity+0x236/frame 0xfffffe023ceef6b0
+# crypto_dispatch() at crypto_dispatch+0xf/frame 0xfffffe023ceef6d0
+# crypto_ioctl() at crypto_ioctl+0x1e33/frame 0xfffffe023ceef7e0
+# devfs_ioctl() at devfs_ioctl+0xcd/frame 0xfffffe023ceef830
+# VOP_IOCTL_APV() at VOP_IOCTL_APV+0x59/frame 0xfffffe023ceef850
+# vn_ioctl() at vn_ioctl+0x133/frame 0xfffffe023ceef960
+# devfs_ioctl_f() at devfs_ioctl_f+0x1e/frame 0xfffffe023ceef980
+# kern_ioctl() at kern_ioctl+0x289/frame 0xfffffe023ceef9f0
+# sys_ioctl() at sys_ioctl+0x12a/frame 0xfffffe023ceefac0
+# amd64_syscall() at amd64_syscall+0x147/frame 0xfffffe023ceefbf0
+# fast_syscall_common() at fast_syscall_common+0xf8/frame 0xfffffe023ceefbf0
+# --- syscall (0, FreeBSD ELF64, nosys), rip = 0x8003827da, rsp = 0x7fffffffe4e8, rbp = 0x7fffffffe540 ---
+# KDB: enter: panic
+# [ thread pid 18612 tid 109119 ]
+# Stopped at kdb_enter+0x37: movq $0,0x1281a2e(%rip)
+# db> x/s version
+# version: FreeBSD 14.0-CURRENT #0 main-n246560-2018d488628: Sat May 8 08:32:52 CEST 2021
+# pho@t2.osted.lan:/usr/src/sys/amd64/compile/PHO
+# db>
+
+[ `uname -p` != "amd64" ] && exit 0
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+cat > /tmp/syzkaller37.c <<EOF
+// https://syzkaller.appspot.com/bug?id=9c74fee9d6ceabfff73819e94328a18723217cf9
+// autogenerated by syzkaller (https://github.com/google/syzkaller)
+// Reported-by: syzbot+220faa5eeb4d47b23877@syzkaller.appspotmail.com
+
+#define _GNU_SOURCE
+
+#include <pwd.h>
+#include <stdarg.h>
+#include <stdbool.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/endian.h>
+#include <sys/syscall.h>
+#include <unistd.h>
+
+uint64_t r[1] = {0xffffffffffffffff};
+
+int main(void)
+{
+ syscall(SYS_mmap, 0x20000000ul, 0x1000000ul, 7ul, 0x1012ul, -1, 0ul);
+ intptr_t res = 0;
+ memcpy((void*)0x20000340, "/dev/crypto\000", 12);
+ res = syscall(SYS_openat, 0xffffffffffffff9cul, 0x20000340ul, 0ul, 0ul);
+ if (res != -1)
+ r[0] = res;
+ *(uint32_t*)0x20000040 = 0x10;
+ *(uint32_t*)0x20000044 = 0x1d;
+ *(uint32_t*)0x20000048 = 1;
+ *(uint64_t*)0x20000050 = 0x20000080;
+ memset((void*)0x20000080, 66, 1);
+ *(uint32_t*)0x20000058 = 0;
+ *(uint64_t*)0x20000060 = 0;
+ *(uint32_t*)0x20000068 = 0;
+ *(uint32_t*)0x2000006c = 0xfdffffff;
+ *(uint32_t*)0x20000070 = 0;
+ *(uint32_t*)0x20000074 = 0;
+ *(uint32_t*)0x20000078 = 0;
+ *(uint32_t*)0x2000007c = 0;
+ syscall(SYS_ioctl, r[0], 0xc040636aul, 0x20000040ul);
+ *(uint32_t*)0x20000000 = 0;
+ *(uint16_t*)0x20000004 = 2;
+ *(uint16_t*)0x20000006 = 0;
+ *(uint32_t*)0x20000008 = 0;
+ *(uint32_t*)0x2000000c = 0x10001;
+ *(uint32_t*)0x20000010 = 0;
+ *(uint64_t*)0x20000018 = 0;
+ *(uint64_t*)0x20000020 = 0;
+ *(uint64_t*)0x20000028 = 0x200001c0;
+ *(uint64_t*)0x20000030 = 0x20000380;
+ *(uint64_t*)0x20000038 = 0;
+ syscall(SYS_ioctl, r[0], 0xc040636dul, 0x20000000ul);
+ return 0;
+}
+EOF
+mycc -o /tmp/syzkaller37 -Wall -Wextra -O0 /tmp/syzkaller37.c ||
+ exit 1
+
+kldload cryptodev.ko && loaded=1
+(cd /tmp; timeout 3m ./syzkaller37)
+[ $loaded ] && kldunload cryptodev.ko
+
+rm -rf /tmp/syzkaller37 syzkaller37.c /tmp/syzkaller.*
+exit 0
diff --git a/tools/test/stress2/misc/syzkaller38.sh b/tools/test/stress2/misc/syzkaller38.sh
new file mode 100755
index 000000000000..2bd42e98a644
--- /dev/null
+++ b/tools/test/stress2/misc/syzkaller38.sh
@@ -0,0 +1,63 @@
+#!/bin/sh
+
+# panic: Assertion (cnp->cn_flags & (LOCKPARENT | WANTPARENT)) == 0 failed at ../../../kern/vfs_lookup.c:490
+# cpuid = 22
+# time = 1620845561
+# KDB: stack backtrace:
+# db_trace_self_wrapper() at db_trace_self_wrapper+0x2b/frame 0xfffffe01499e7690
+# vpanic() at vpanic+0x181/frame 0xfffffe01499e76e0
+# panic() at panic+0x43/frame 0xfffffe01499e7740
+# namei() at namei+0xb4e/frame 0xfffffe01499e77f0
+# vn_open_cred() at vn_open_cred+0x11d/frame 0xfffffe01499e7960
+# kern_openat() at kern_openat+0x28f/frame 0xfffffe01499e7ac0
+# amd64_syscall() at amd64_syscall+0x147/frame 0xfffffe01499e7bf0
+# fast_syscall_common() at fast_syscall_common+0xf8/frame 0xfffffe01499e7bf0
+# --- syscall (0, FreeBSD ELF64, nosys), rip = 0x80038254a, rsp = 0x7fffffffe4f8, rbp = 0x7fffffffe540 ---
+# KDB: enter: panic
+# [ thread pid 2990 tid 100320 ]
+# Stopped at kdb_enter+0x37: movq $0,0x12819de(%rip)
+# db> x/s version
+# version: FreeBSD 14.0-CURRENT #0 main-n246600-e681dd3e2c1-dirty: Wed May 12 07:56:58 CEST 2021
+# pho@t2.osted.lan:/usr/src/sys/amd64/compile/PHO\012
+# db>
+
+# Fixed by: 6de3cf14c47d - main - vn_open_cred(): disallow O_CREAT | O_EMPTY_PATH
+
+[ `uname -p` != "amd64" ] && exit 0
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+cat > /tmp/syzkaller38.c <<EOF
+// https://syzkaller.appspot.com/bug?id=72344b68a3a10a92bf1ef18b0c8286409c81b1c9
+// autogenerated by syzkaller (https://github.com/google/syzkaller)
+// Reported-by: syzbot+dbfd5b122ad66ae9a14b@syzkaller.appspotmail.com
+
+#define _GNU_SOURCE
+
+#include <pwd.h>
+#include <stdarg.h>
+#include <stdbool.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/endian.h>
+#include <sys/syscall.h>
+#include <unistd.h>
+
+int main(void)
+{
+ syscall(SYS_mmap, 0x20000000ul, 0x1000000ul, 7ul, 0x1012ul, -1, 0ul);
+
+ memset((void*)0x20000180, 0, 1);
+ syscall(SYS_open, 0x20000180ul, 0x20c0200ul, 0ul);
+ return 0;
+}
+EOF
+mycc -o /tmp/syzkaller38 -Wall -Wextra -O0 /tmp/syzkaller38.c ||
+ exit 1
+
+(cd /tmp; timeout 3m ./syzkaller38)
+
+rm -rf /tmp/syzkaller38 syzkaller38.c /tmp/syzkaller.*
+exit 0